/*
    Solar - a solar system simulator
    Copyright (C) 2004, 2005  Sam Morris <sam@robots.org.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef SOLAR_PLANETWINDOW_H
#define SOLAR_PLANETWINDOW_H

#include <gtkmm.h>

#include "Planet.h"

namespace solar {

        class PlanetWindow: public Gtk::Dialog
        {
        public:
                PlanetWindow(Planet *planet);

                /**
                 * Updates the specified planet to match the settings in the
                 * dialog.
                 * TODO: make dialog set this when Ok button pressed.
                 */
                void updatePlanet(Planet& p);

        private:
                std::string getName();
                double getMass();
                double getRadius();

                Vector getPosition();
                Vector getVelocity();
                Vector getColour();

        //private:
                Planet *planet;

                Gtk::VBox *vBox;

                Gtk::Frame nameFrame, massFrame, radiusFrame;
                Gtk::Entry nameEntry, massEntry, radiusEntry;

                Gtk::HBox doubleHBox;
                Gtk::HBox vectorHBox;

                Gtk::Frame positionFrame, velocityFrame, colourFrame;
                Gtk::Table positionTable, velocityTable;

                Gtk::Label positionXLabel, positionYLabel, positionZLabel;
                Gtk::Entry positionXEntry, positionYEntry, positionZEntry;

                Gtk::Label velocityXLabel, velocityYLabel, velocityZLabel;
                Gtk::Entry velocityXEntry, velocityYEntry, velocityZEntry;

                Gtk::ColorSelection colourSelection;
        };

        double toDouble(const std::string& string);
}

#endif
